// MapConvDlg.cpp : implementation file
//
#include "stdafx.h"
#include "MapConv.h"
#include "MapConvDlg.h"

#pragma warning(disable : 4786)
#include <vector>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapConvDlg dialog

CMapConvDlg::CMapConvDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMapConvDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMapConvDlg)
	m_sInLongitude = _T("");
	m_sInLatitude = _T("");
	m_sOutX = _T("");
	m_sOutY = _T("");
	m_iInCboEllips = kBessel1984;
	m_iInCboSystem = kTmMid;
	m_sInX = _T("");
	m_sInXDegree = _T("");
	m_sInXMinute = _T("");
	m_sInXSecond = _T("");
	m_sInY = _T("");
	m_sInYDegree = _T("");
	m_sInYMinute = _T("");
	m_sInYSecond = _T("");
	m_iOutCboEllips = kBessel1984;
	m_iOutCboSystem = -1;
	m_sOutLatitude = _T("");
	m_sOutLongitude = _T("");
	m_sOutXDegree = _T("");
	m_sOutXMinute = _T("");
	m_sOutXSecond = _T("");
	m_sOutYDegree = _T("");
	m_sOutYMinute = _T("");
	m_sOutYSecond = _T("");
	m_iOutCboSystem = kGeographic;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMapConvDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMapConvDlg)
	DDX_Text(pDX, IDC_IN_LONGITUDE, m_sInLongitude);
	DDX_Text(pDX, IDC_IN_LATITUDE, m_sInLatitude);
	DDX_Text(pDX, IDC_OUT_X, m_sOutX);
	DDX_Text(pDX, IDC_OUT_Y, m_sOutY);
	DDX_CBIndex(pDX, IDC_IN_CBOELLIPS, m_iInCboEllips);
	DDX_CBIndex(pDX, IDC_IN_CBOSYSTEM, m_iInCboSystem);
	DDX_Text(pDX, IDC_IN_X, m_sInX);
	DDX_Text(pDX, IDC_IN_X_DEGREE, m_sInXDegree);
	DDX_Text(pDX, IDC_IN_X_MINUTE, m_sInXMinute);
	DDX_Text(pDX, IDC_IN_X_SECOND, m_sInXSecond);
	DDX_Text(pDX, IDC_IN_Y, m_sInY);
	DDX_Text(pDX, IDC_IN_Y_DEGREE, m_sInYDegree);
	DDX_Text(pDX, IDC_IN_Y_MINUTE, m_sInYMinute);
	DDX_Text(pDX, IDC_IN_Y_SECOND, m_sInYSecond);
	DDX_CBIndex(pDX, IDC_OUT_CBOELLIPS, m_iOutCboEllips);
	DDX_CBIndex(pDX, IDC_OUT_CBOSYSTEM, m_iOutCboSystem);
	DDX_Text(pDX, IDC_OUT_LATITUDE, m_sOutLatitude);
	DDX_Text(pDX, IDC_OUT_LONGITUDE, m_sOutLongitude);
	DDX_Text(pDX, IDC_OUT_X_DEGREE, m_sOutXDegree);
	DDX_Text(pDX, IDC_OUT_X_MINUTE, m_sOutXMinute);
	DDX_Text(pDX, IDC_OUT_X_SECOND, m_sOutXSecond);
	DDX_Text(pDX, IDC_OUT_Y_DEGREE, m_sOutYDegree);
	DDX_Text(pDX, IDC_OUT_Y_MINUTE, m_sOutYMinute);
	DDX_Text(pDX, IDC_OUT_Y_SECOND, m_sOutYSecond);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMapConvDlg, CDialog)
	//{{AFX_MSG_MAP(CMapConvDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CMD_TRANCE, OnCmdTrance)
	ON_EN_KILLFOCUS(IDC_IN_LONGITUDE, OnKillfocusInLongitude)
	ON_EN_KILLFOCUS(IDC_IN_LATITUDE, OnKillfocusInLatitude)
	ON_EN_KILLFOCUS(IDC_IN_X_DEGREE, OnKillfocusInXDms)
	ON_EN_KILLFOCUS(IDC_IN_Y_DEGREE, OnKillfocusInYDms)
	ON_CBN_SELCHANGE(IDC_IN_CBOSYSTEM, OnSelchangeInCbosystem)
	ON_EN_KILLFOCUS(IDC_IN_X_MINUTE, OnKillfocusInXDms)
	ON_EN_KILLFOCUS(IDC_IN_X_SECOND, OnKillfocusInXDms)
	ON_EN_KILLFOCUS(IDC_IN_Y_MINUTE, OnKillfocusInYDms)
	ON_EN_KILLFOCUS(IDC_IN_Y_SECOND, OnKillfocusInYDms)
	ON_BN_CLICKED(IDC_CMD_FILE_CONVERT, OnCmdFileConvert)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMapConvDlg message handlers

BOOL CMapConvDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	OnSelchangeInCbosystem();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMapConvDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMapConvDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMapConvDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMapConvDlg::OnCmdTrance() 
{
	UpdateData(TRUE);
	
	double dInX, dInY;

	double dOutX, dOutY;
	double dOutLon, dOutLat;
	int iDeg, iMin;
	double dSec;

	// 켱  ȯ
	m_CoordConv.SetSrcType((GeoEllips)m_iInCboEllips, (GeoSystem)m_iInCboSystem);
	m_CoordConv.SetDstType((GeoEllips)m_iOutCboEllips, (GeoSystem)m_iOutCboSystem);

	// Display Result
	if (m_iInCboSystem == kGeographic)
	{
		// Get Geographic Value
		dInX = atof(m_sInLongitude);
		dInY = atof(m_sInLatitude);
		m_CoordConv.Conv(dInX, dInY, dOutLon, dOutLat);
	}
	else {
		// Get Geographic Value
		dInX = atof(m_sInX);
		dInY = atof(m_sInY);
		m_CoordConv.Conv(dInX, dInY, dOutLon, dOutLat);
	}

	//   ÷
	m_sOutLongitude.Format("%.10f", dOutLon);
	m_sOutLatitude.Format("%.10f", dOutLat);
	
	CGeoCoordConv::D2Dms(dOutLon, iDeg, iMin, dSec);
	m_sOutXDegree.Format("%i", iDeg);
	m_sOutXMinute.Format("%i", iMin);
	m_sOutXSecond.Format("%.4f", dSec);

	CGeoCoordConv::D2Dms(dOutLat, iDeg, iMin, dSec);
	m_sOutYDegree.Format("%i", iDeg);
	m_sOutYMinute.Format("%i", iMin);
	m_sOutYSecond.Format("%.4f", dSec);

	// TM  ÷
	if (m_iOutCboSystem == kGeographic)
	{
		m_sOutX = "";
		m_sOutY = "";
	}
	else 
	{
		m_CoordConv.SetSrcType((GeoEllips)m_iInCboEllips, (GeoSystem)m_iInCboSystem);
		m_CoordConv.SetDstType((GeoEllips)m_iOutCboEllips, (GeoSystem)m_iOutCboSystem);
		m_CoordConv.Conv(dInX, dInY, dOutX, dOutY);

		m_sOutX.Format("%.4f", dOutX);
		m_sOutY.Format("%.4f", dOutY);
	}

	UpdateData(FALSE);
}

void CMapConvDlg::OnKillfocusInLongitude() 
{
	double dInLon;
	int iDeg, iMin;
	double dSec;

	UpdateData(TRUE);

	// Get Geographic Value
	dInLon = atof(m_sInLongitude);
	m_sInLongitude.Format("%.10f", dInLon);

	// Display Input Geographic Value
	m_sInLongitude.Format("%.10f", dInLon);

	CGeoCoordConv::D2Dms(dInLon, iDeg, iMin, dSec);
	m_sInXDegree.Format("%i", iDeg);
	m_sInXMinute.Format("%i", iMin);
	m_sInXSecond.Format("%.4f", dSec);

	UpdateData(FALSE);
}

void CMapConvDlg::OnKillfocusInLatitude() 
{
	double dInLat;
	int iDeg, iMin;
	double dSec;

	UpdateData(TRUE);

	// Get Geographic Value
	dInLat = atof(m_sInLatitude);
	m_sInLatitude.Format("%.10f", dInLat);

	// Display Input Geographic Value
	m_sInLatitude.Format("%.10f", dInLat);

	CGeoCoordConv::D2Dms(dInLat, iDeg, iMin, dSec);
	m_sInYDegree.Format("%i", iDeg);
	m_sInYMinute.Format("%i", iMin);
	m_sInYSecond.Format("%.4f", dSec);

	UpdateData(FALSE);
}


void CMapConvDlg::OnKillfocusInXDms() 
{
	double dInLon;

	UpdateData(TRUE);

	dInLon = (double)atoi(m_sInXDegree) + atoi(m_sInXMinute)/60.0 + atof(m_sInXSecond)/3600.0;
	m_sInLongitude.Format("%.10f", dInLon);

	UpdateData(FALSE);
}

void CMapConvDlg::OnKillfocusInYDms() 
{
	double dInLat;

	UpdateData(TRUE);

	dInLat = (double)atoi(m_sInYDegree) + atoi(m_sInYMinute)/60.0 + atof(m_sInYSecond)/3600.0;
	m_sInLatitude.Format("%.10f", dInLat);

	UpdateData(FALSE);
}

void CMapConvDlg::OnSelchangeInCbosystem() 
{
	UpdateData(TRUE);
	if (m_iInCboSystem == (GeoSystem)kGeographic)
	{
		GetDlgItem(IDC_IN_LONGITUDE)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_LATITUDE)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_X_DEGREE)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_X_MINUTE)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_X_SECOND)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_Y_DEGREE)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_Y_MINUTE)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_Y_SECOND)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_X)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_Y)->EnableWindow(FALSE);
	}
	else {
		GetDlgItem(IDC_IN_LONGITUDE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_LATITUDE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_X_DEGREE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_X_MINUTE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_X_SECOND)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_Y_DEGREE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_Y_MINUTE)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_Y_SECOND)->EnableWindow(FALSE);
		GetDlgItem(IDC_IN_X)->EnableWindow(TRUE);
		GetDlgItem(IDC_IN_Y)->EnableWindow(TRUE);
	}
}

// Ϸ Ǿ ִ ǥ ϰ ȯ  ߰ ƾ.(2004-06-06 Shin, Sanghee shshin@gaia3d.com)
void CMapConvDlg::OnCmdFileConvert() 
{
	UpdateData(TRUE);		// ̾α   ɼ Ȯ...

	UINT	nNO_ID = 0;		// ȯ ǥ  2004-06-06 Shin, Sanghee
//	UINT	nID;			// ǥ տ ִ ID ȣ..
	
	// vector° ? delete ϴ  .. ׳ vector ...
	vector<double> vIn_X;	// Է X ǥ
	vector<double> vIn_Y;	// Է Y ǥ
	vector<double> vOut_X;	// Է X ǥ
	vector<double> vOut_Y;	// Է Y ǥ
	
	CString PathName;		// Է ϸ..
	FILE*	fp;				// Է 
	FILE*	fp_out;			//  

	/*	ʷ  ϴ° ?
	int iDeg, iMin;
	double dSec;
	*/

	// ǥ ȯ  ..
	m_CoordConv.SetSrcType((GeoEllips)m_iInCboEllips, (GeoSystem)m_iInCboSystem);
	m_CoordConv.SetDstType((GeoEllips)m_iOutCboEllips, (GeoSystem)m_iOutCboSystem);

	// Է  ҷ.. 2004-06-06 by Shin, Sanghee
	char szFilter[] = "TEXT  Files (*.txt)|*.txt|ASCII Files  (*.asc)|*.asc|All Files (*.*)|*.*|";
	CFileDialog fileDlg(TRUE, NULL, NULL, OFN_HIDEREADONLY, szFilter);

	if(IDOK==fileDlg.DoModal())
	{
		PathName = fileDlg.GetFileTitle();
		fp=fopen(fileDlg.GetPathName(), "r");
	}
	else
		return;

	//  Է  ϴ ľ.. ̰  ΰ?
	char t;
	while((t=fgetc(fp))!=EOF)
	{
		if(t=='\n')
			nNO_ID++;
	}

	// ͸ ٽ ó..
	rewind(fp);

	// vector  Ҵ.. vector reserve  ִ° push_backϴ   ӵ ..
	vIn_X.reserve(nNO_ID);
	vIn_Y.reserve(nNO_ID);
	vOut_X.reserve(nNO_ID);
	vOut_Y.reserve(nNO_ID);

	//  ȯ ǥ  ˾  鼭 о..
	for(int i = 0; i < nNO_ID; ++i)
	{
//		fscanf(fp, "%d", &nID);
		fscanf(fp, "%lf", &vIn_X[i]);
		fscanf(fp, "%lf", &vIn_Y[i]);
	}
	
	//  о   ǥ ȯ ..
	for(i = 0 ; i < nNO_ID; ++i)
		m_CoordConv.Conv(vIn_X[i], vIn_Y[i], vOut_X[i], vOut_Y[i]);

	// ǥ ȯ   غ..
	PathName = PathName + "_Result.txt";	//  ϸ ְ..
	fp_out=fopen(PathName, "w+");

	//  ɼǿ  ..
	if (m_iOutCboSystem == kGeographic)		//  ̸...
	{
		for(int i = 0; i < nNO_ID; ++i)
		{
			//   ÷̸  ȣ ־ ڰ غ...
			/*
			CGeoCoordConv::D2Dms(vOut_X[i], iDeg, iMin, dSec);
			fprintf(fp_out, "%d%s %d%s %d%s %.3lf%s %s ", i+1, "," , iDeg, "", iMin, "", dSec, "", ",");

			CGeoCoordConv::D2Dms(vOut_Y[i], iDeg, iMin, dSec);
			fprintf(fp_out, "%d%s %d%s %.3lf%s ", iDeg, "", iMin, "", dSec, "");
			fprintf(fp_out, "\n");
			*/
			fprintf(fp_out, "%.10lf %.10lf\n", vOut_X[i], vOut_Y[i]);
		}
	}
	else		// ǥ ̸...
	{
		for(int i = 0; i < nNO_ID; ++i)
			fprintf(fp_out, "%.3lf %.3lf\n", vOut_X[i], vOut_Y[i]);
	}

	fclose(fp);
	fclose(fp_out);
}
