// MapConvDlg.h : header file
//

#include "GeoCoordConv.h"

#if !defined(AFX_MAPCONVDLG_H__9FCB157D_C618_4AA4_8D38_520915B0D0E6__INCLUDED_)
#define AFX_MAPCONVDLG_H__9FCB157D_C618_4AA4_8D38_520915B0D0E6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CMapConvDlg dialog

class CMapConvDlg : public CDialog
{
// Construction
public:
	CMapConvDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMapConvDlg)
	enum { IDD = IDD_MAPCONV_DIALOG };
	CString	m_sInLongitude;
	CString	m_sInLatitude;
	CString	m_sOutX;
	CString	m_sOutY;
	int		m_iInCboEllips;
	int		m_iInCboSystem;
	CString	m_sInX;
	CString	m_sInXDegree;
	CString	m_sInXMinute;
	CString	m_sInXSecond;
	CString	m_sInY;
	CString	m_sInYDegree;
	CString	m_sInYMinute;
	CString	m_sInYSecond;
	int		m_iOutCboEllips;
	int		m_iOutCboSystem;
	CString	m_sOutLatitude;
	CString	m_sOutLongitude;
	CString	m_sOutXDegree;
	CString	m_sOutXMinute;
	CString	m_sOutXSecond;
	CString	m_sOutYDegree;
	CString	m_sOutYMinute;
	CString	m_sOutYSecond;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMapConvDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	CGeoCoordConv m_CoordConv;
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CMapConvDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnCmdTrance();
	afx_msg void OnKillfocusInLongitude();
	afx_msg void OnKillfocusInLatitude();
	afx_msg void OnKillfocusInXDms();
	afx_msg void OnKillfocusInYDms();
	afx_msg void OnSelchangeInCbosystem();
	afx_msg void OnCmdFileConvert();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAPCONVDLG_H__9FCB157D_C618_4AA4_8D38_520915B0D0E6__INCLUDED_)
